package jp.co.timedia.shop.control;

import java.util.*;
import java.io.IOException;
import javax.servlet.http.*;
import jp.co.timedia.control.*;
import jp.co.timedia.shop.model.*;

public class AddItemToCart extends Action {

    public AddItemToCart(String actionURL) {
	super(actionURL);
    }

    public void execute(Controller controller) throws IOException {
	Catalog catalog = ((Shop) controller).getCatalog();
	Cart cart = ((Shop) controller).getCart();
	HttpServletRequest request = controller.getRequest();
	Enumeration e = request.getParameterNames(); 
	while (e.hasMoreElements()) {
	    String id = (String) e.nextElement();
	    if (id.startsWith(Item.ID)) {
		Item item = (Item) ((Item) catalog.getItem(id)).clone();
		String numberString = request.getParameter(id);
		try {
		    int number = Integer.parseInt(numberString);
		    if (number < 0) numberString = "0";
		    item.setNumber(numberString);
		    cart.add(item);
		} catch (NumberFormatException ex) {
		}
	    }
	}
    }
}

