package jp.co.timedia.shop.model;

import java.util.*;

public class Cart {
 
    private TreeMap cart;

    public Cart() {
	init();
    }

    public void init() {
	if (cart == null) {
	    cart = new TreeMap();
	} else {
	    cart.clear();
	}
    }

    public Collection getList() {
	return cart.values();
    }

    public void add(Item item) {
	if (item.getNumber().equals("0")) {
	    remove(item);
	    return;
	}
	cart.put(item.getId(), item);
    }

    public void remove(Item item) {
	cart.remove(item.getId());
    }

    public String getTotal() {
	return String.valueOf(Math.round(calcurate()));
    }

    private double calcurate() {
	double total = 0.;
	Iterator iterator = cart.values().iterator();
	while(iterator.hasNext()) {
	    Item item = (Item) iterator.next();
	    try {
		int price = Integer.parseInt(item.getPrice());
        	int number = Integer.parseInt(item.getNumber());
		total += price * number;
	    } catch (NumberFormatException e) {
		e.printStackTrace();
	    }
	}
	return total;
    }
}
