package jp.co.timedia.shop.model;

import java.io.*;
import java.util.*;

public class Catalog {

    public static String CATALOG = "catalog.txt";
    public static String ENCODE = "SJIS";
    public static String DELIM = ",";
    public static int NUMBER_PER_PAGE = 5;
    private static ArrayList catalog = new ArrayList();

    public void load(String realPath) throws IOException {
	BufferedReader in = null;
	TreeMap catalogPage = new TreeMap();
	String line;
	in = new BufferedReader(new InputStreamReader(
		new FileInputStream(realPath + CATALOG), ENCODE));
	int count = 0;
	while ((line = in.readLine()) != null) {
	    StringTokenizer st = new StringTokenizer(line, DELIM); 
	    try {
		String id = st.nextToken().trim();
		String name = st.nextToken().trim();
		String price = st.nextToken().trim();
		Item item = new Item(Item.ID + id, name, price);
		catalogPage.put(item.getId(), item);
		count++;
		if (count == NUMBER_PER_PAGE) {
		    catalog.add(catalogPage);
		    catalogPage = new TreeMap();
		    count = 0;
		}
	    } catch (NoSuchElementException e) {
		e.printStackTrace();
	    }
	}
	if (!catalogPage.isEmpty()) {
	    catalog.add(catalogPage);
	}
	    in.close();
    } 

    public TreeMap getCatalog(String page) {
	int number = 0;
	try {
	   number = Integer.parseInt(page);
	} catch (NumberFormatException e) {
	}
	Object obj = null;
	try {
	    obj = catalog.get(number);
	} catch (IndexOutOfBoundsException e) {
	    return new TreeMap();
	}
	TreeMap catalogPage = new TreeMap((TreeMap) obj);
	Iterator iterator = catalogPage.values().iterator();
	while (iterator.hasNext()) {
	    Item item = (Item) iterator.next();
	    item.setNumber("0");
	}
	return catalogPage;
    }

    public Item getItem(String id) {
	Iterator iterator = catalog.iterator();
	while (iterator.hasNext()) {
	    TreeMap catalogPage = (TreeMap) iterator.next();
	    Item item = (Item) catalogPage.get(id);
	    if (item != null) return (Item) item.clone();
	}
	return null;
    }

    public int getMaxPageNumber() {
	return catalog.size();
    }
}
