package jp.co.timedia.shop.model;

public class Item implements Cloneable {

    public static String ID = "FRUITS_ITEM";
    private String id;
    private String name;
    private String price;
    private String number;

    public Item(String id, String name, String price) {
	this.id = id;
	this.name = name;
	this.price = price;
    }

    public void setNumber(String number) {
	try {
	    Integer.parseInt(number.trim());
	    this.number = number;
	} catch (NumberFormatException e) {
	    this.number = "0";
	}
    }

    public String getId() { 
	return id;
    }

    public String getName() {
	return name;
    }

    public String getPrice() {
	return price; 
    }

    public String getNumber() {
	if (number == null) number = "0";
	return number; 
    }

    public Object clone() {
	Item item = new Item(id, name, price);
	item.setNumber(number);
	return item;
    }

}
